/***************************************************
*	Module Name		:	ADC_test		   
*	Engineer		   :	С÷
*	Target Device	:	XC7Z020clg400-2
*	Tool versions	:	VIVADO 2018.3
*	Create Date		:	2021-10-07
*	Revision		   :	v1.0
*	Description		:  ADC Զ
**************************************************/
module ADC_test(
			Clk,
			Rst_n,
			ADC_SCLK,
			ADC_DOUT,
			ADC_DIN,
			ADC_CS_N,	
			DAC_CS_N,
			DAC_DIN,
			DAC_SCLK
		);

	input Clk;	//ʱ
	input Rst_n; //λ룬͵ƽλ

	output DAC_CS_N;
	output DAC_DIN;
	output DAC_SCLK;	
	
	input   ADC_DOUT;	 //ADCתADCFPGA
	output  ADC_SCLK;	 //ADC ݽӿʱź
	output  ADC_CS_N;  //ADC ݽӿʹź
	output  ADC_DIN;	 //ADCźFPGAָͨADC	
		
	wire [11:0] ADC_Data;
	wire [2:0] ADC_Channel;
	wire Conv_Done;	
	wire [15:0] DAC_DATA;
	reg [15:0]r_DAC_DATA;
	reg Start;
	wire DAC_State;

	
	vio_0 vio_0(
        .clk(Clk),	
		.probe_out0(DAC_DATA)
		);
	
	tlv5618 tlv5618(
		.Clk(Clk),
		.Rst_n(Rst_n),
		
		.DAC_DATA(DAC_DATA),
		.Start(Start),
		.Set_Done(),
		
		.DAC_CS_N(DAC_CS_N),
		.DAC_DIN(DAC_DIN),
		.DAC_SCLK(DAC_SCLK),
		.DAC_State(DAC_State)
	);
	
	
	always@(posedge Clk or negedge Rst_n)
	if(!Rst_n)
		r_DAC_DATA <= 16'd0;
	else if(DAC_State)
		r_DAC_DATA <= DAC_DATA;
		
	always@(posedge Clk or negedge Rst_n)
	if(!Rst_n)
		Start <= 1'd0;
	else if(r_DAC_DATA != DAC_DATA) 
		Start <= 1'b1;
	else
		Start <= 1'd0;

	vio_1 vio_1 (
	    .clk(Clk),
		.probe_out0 (ADC_Channel), // sources.source
		.probe_in0  (ADC_Data)   //  probes.probe
	);
	
	adc128s102 adc128s102(
		.Clk(Clk),
		.Rst_n(Rst_n),
		
		.Channel(ADC_Channel),
		.Data(ADC_Data),
		
		.En_Conv(Conv_Done),
		.Conv_Done(),
		.ADC_State(Conv_Done),
		.DIV_PARAM(8'd13),
		
		.ADC_SCLK(ADC_SCLK),
		.ADC_DOUT(ADC_DOUT),
		.ADC_DIN(ADC_DIN),
		.ADC_CS_N(ADC_CS_N)
	);



endmodule 